#!/bin/bash
# Test suite for perl examples.
#
# Copyright (C) 2004  Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Library Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# This is called from plplot-test.sh with $perldir, $device, $dsuffix,
# $options, and possibly $verbose_test defined.

# To build the c examples before running this script do the following:
# pushd $cdir; make; popd

# Do the standard non-interactive examples.

# Ensure correct version of the libraries are picked up in both the build
# tree and install tree.
lang="pdl"
if [ "$LD_LIBRARY_PATH" = "" ] ; then
    export LD_LIBRARY_PATH=../src:"/usr/lib64"
else
    export LD_LIBRARY_PATH=../src:"/usr/lib64":$LD_LIBRARY_PATH
fi

if [ "ON" = "ON" ] ; then
    INDEX_LIST="01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31"
else
  # Examples 02, 20, 21, 23, 24, 28, 29, and 30 require PDL::Graphics::PLplot
  # version 0.46 or later.
    INDEX_LIST="01 03 04 05 06 07 08 09 10 11 12 13 15 16 18 19 22 25 26 27"
fi

for index in $INDEX_LIST ; do
    if [ "$verbose_test" ] ; then
	echo "x${index}.pl"
    fi
    if [ "$index" = "14" ] ; then
	echo "${OUTPUT_DIR}"/x${index}a${lang}%n.$dsuffix | \
	"$perldir"/x${index}.pl -dev $device -o "${OUTPUT_DIR}"/x${index}${lang}%n.$dsuffix \
	    $options 2> test.error >| "${OUTPUT_DIR}"/x${index}${lang}_${dsuffix}.txt
	status_code=$?
    else
	"$perldir"/x${index}.pl -dev $device -o "${OUTPUT_DIR}"/x${index}${lang}%n.$dsuffix $options 2> test.error >| "${OUTPUT_DIR}"/x${index}${lang}_${dsuffix}.txt
	status_code=$?
    fi
    cat test.error
    if [ "$status_code" -ne 0 ] ; then
	exit $status_code
    fi
  # Look for any PLPLOT ERROR messages from plwarn that do not result in an
  # exit code.
    is_error=`grep -l 'PLPLOT ERROR' test.error`
    if [ -n "$is_error" ] ; then
	exit 1
    fi
done
